/*
*    Copyright (c) <2002-2005> <Jean-Philippe Barrette-LaPierre>
*    
*    Permission is hereby granted, free of charge, to any person obtaining
*    a copy of this software and associated documentation files 
*    (curlpp), to deal in the Software without restriction, 
*    including without limitation the rights to use, copy, modify, merge,
*    publish, distribute, sublicense, and/or sell copies of the Software,
*    and to permit persons to whom the Software is furnished to do so, 
*    subject to the following conditions:
*    
*    The above copyright notice and this permission notice shall be included
*    in all copies or substantial portions of the Software.
*    
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
*    OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#include <iostream>
#include <fstream>

#include <curlpp/curlpp.hpp>
#include <curlpp/http_easy.hpp>


int main(int argc, char **argv) {
  char buf[100];
  long size;
  char *filename;
  char *url;

  if(argc != 4) {
    std::cerr << "example02: Arguments missing." << std::endl;
    std::cerr << "example02: Usage: example02 url filename filesize" << std::endl;
    
    return EXIT_FAILURE;
  }

  url = argv[1];
  filename = argv[2];
  size = atoi(argv[3]);



  std::list<std::string> headers;
  headers.push_back("Content-Type: text/*");
  sprintf(buf, "Content-Length: %ld", size);
  headers.push_back(buf);

  try
    { 
      curlpp::initialize();
      curlpp::http_easy handle;

      handle.url(url);
      handle.http_header(headers);

      std::ifstream my_file(filename);
      curlpp::istream_trait my_trait( &my_file );
      handle.m_input_storage.trait( &my_trait, false );
      handle.infile_size(size);
      handle.upload();

      handle.verbose();
      handle.perform();
    }
  catch(curlpp::exception &e) 
    {
      std::cerr << e.what() << std::endl;
    }
}
