/*
 *    Copyright (c) <2002-2005> <Jean-Philippe Barrette-LaPierre>
 *    
 *    Permission is hereby granted, free of charge, to any person obtaining
 *    a copy of this software and associated documentation files 
 *    (curlpp), to deal in the Software without restriction, 
 *    including without limitation the rights to use, copy, modify, merge,
 *    publish, distribute, sublicense, and/or sell copies of the Software,
 *    and to permit persons to whom the Software is furnished to do so, 
 *    subject to the following conditions:
 *    
 *    The above copyright notice and this permission notice shall be included
 *    in all copies or substantial portions of the Software.
 *    
 *    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 *    OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 *    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 *    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 *    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#include <curlpp/curlpp.hpp>
#include <fstream>

int main(int argc, char** argv)
{
  if(argc != 3) {
    std::cerr << "example08: Wrong number of argument." << std::endl;
    std::cerr << "example08: Usage: example08 url local_filename" << std::endl;

    return EXIT_FAILURE;
  }

  try {
    curlpp::cleanup cleaner;
    curlpp::easy request;
    request.url(argv[1]);
      
    std::ofstream file(argv[2]);
    curlpp::ostream_trait trait( &file );
    request.m_body_storage.trait( &trait );
      
    request.progress();
      
    request.perform();
  }
  catch ( curlpp::exception & e ) {
    std::cout << e.what() << std::endl;
  }
  return 0;
}
